# Contributing

When contributing to this repository, please first discuss the change you wish to make via
issue, email, twitter, or any other method with the owners of this repository before making a change.

## Pull Request Process

1) fork the project
2) if you're fixing a bug also create an issue if one doesn't exist yet
3) if it's a new feature explain why do you think it's necessary
4) do not include changes that are not related to the issue at hand
5) follow the same coding style with regards to spaces, semicolons, variable naming etc
6) add tests
7) make sure you install all dependencies by running `npm i`
8) make sure you tested your code by running `npm test`
9) if changing C/C++ code, you must verify that NAPI and WASM both pass tests
10) when you think the code is ready for review a pull request should be created

## Code of Conduct

This project adheres to No Code of Conduct.  We are all adults.  We accept anyone's contributions.  Nothing else matters.
For more information please visit the [No Code of Conduct](https://github.com/domgetter/NCoC) homepage.
